/*
 * @author Bobby Kramer, released under GPL v 2.0
 */
package polygraph;
import java.applet.Applet;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.Timer;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import org.nfunk.jep.JEP;

public class GraphNum extends JPanel {
	private static final long serialVersionUID = 1L;
	public static final int HEIGHT=600;
	public static final int WIDTH=700;
	private ArrayList outputList;
	private Color  eq_1_Color;
	
	public GraphNum(){
		this.eq_1_Color = Color.RED;
		this.setupSystem();
	}

	//node count: used for how many nodes are going to be present in this zoom view.
	public void setupSystem(){
		this.outputList = new ArrayList();

	}
	public void resetGraph(){
		this.outputList = new ArrayList();
	}

	public void paint(Graphics g){
		g.setColor(Color.BLACK);
		g.fillRect(0, 0, 400, 700);
		g.setColor(eq_1_Color);
		for(int a=0; a<this.outputList.size(); a++){
			Point p = (Point)(this.outputList.get(a));
			g.drawLine(p.x, p.y, p.x, p.y);
		}
	
	}
	//y=pixel stretch ratio*(k*x^2 + b)
	/**
	 * Finds/adds point to the proper pixel on our graph.
	 * 
	 * It does this by rounding relative to the coefficient (ie- how many numbers per pixel).
	 * 
	 * 
	 */
	public void findPoints(double val, double coefficient, double startVal, double eqConstant){
		double y = 0;
		double nearest_square=0;
		double difference =0;
		if(val >=1 || val <= -1){
			if(((val-startVal)/coefficient) < 0){
				double testVal=((val-startVal)/coefficient)*-1;
				nearest_square = Math.floor((Math.sqrt((testVal))));
			}
			else{
				nearest_square = Math.floor((Math.sqrt(((val-startVal)/coefficient))));
			}
		 
		 difference = (val-startVal)-(coefficient * Math.pow((double)nearest_square, 2));
		 y = difference/coefficient;
		}
		else{
			//TODO:Need to add this for less than 1, needs to calculate the less than 1 square
			double[] lessThanOneSquareInfo = findNearestSquareLessThanOne(coefficient,val, startVal);
			nearest_square = lessThanOneSquareInfo[1];
			//difference = (val-startVal)-( Math.pow((double)lessThanOneSquareInfo[0], 2));
			//System.out.println(" THE DIFFERENCE IS " +lessThanOneSquareInfo[2] + " BETWEEN " +lessThanOneSquareInfo[0] + " AND " + val  );
			y = lessThanOneSquareInfo[2]/coefficient;
		}
		int PointY =(int)( Math.round(y));
		int PointX = (int)nearest_square;
		//System.out.println("VAL" + val + "  Point X" + PointX + " Point Y" + PointY + " nearestSquare" + nearest_square + " y" + y);
		Point p = new Point();
		p.y = PointY+1;
		p.x = PointX+1;
		this.outputList.add((Object) p);
	}
	/**
	 * For consistancy, we want to make sure it processes everything as it should between -1 and 1. Everything else should work fine.	
	 * TODO: Make sure negitive numbers output correctly
	 */
	public double[] findNearestSquareLessThanOne(double coefficient, double result, double startVal){
		double[] returnVal = new double[3];
		double tmp=0;
		double testval=0;
		do{
			tmp++;
			testval =(coefficient*tmp*tmp)+startVal; //multiply the squares
			
		}while (testval < result );
		tmp--;
		testval =coefficient*tmp*tmp +startVal;
		returnVal[0] = testval;
		returnVal[1] = tmp;		
		returnVal[2] = (result-testval);//this is the difference, used for calculating the y axis
		//System.out.println("RETURNING TESTVAL OF " + testval + " COEFICCIENT " + coefficient + " X^2: " + tmp);
		return returnVal;
	}
	/**
	 * Parses a result of a equation ran from JEP
	 * for equation 1
	 * @param result the result that JEP returned
	 */
	public void parseEQ1Result(double result, double coefficient, double startVal, double eqConstant){
			findPoints(result, coefficient,startVal,eqConstant);
		

	}
	/**
	 * Parses a result of a equation ran from JEP
	 * for equation 2
	 * @param result the result that JEP returned
	 */
	public void  setEQ1Color(Color c){
		this.eq_1_Color = c;
	}
	public Color getEQ1Color(){
		return this.eq_1_Color;
	}





}
